<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="DoxyPress 1.2.10"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>Commanders: CANCommanderClass Class Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="resize.js"></script>
<script type="text/javascript" src="navtreedata.js"></script>
<script type="text/javascript" src="navtree.js"></script>
<script type="text/javascript">
  $(document).ready(initResizable);
  $(window).load(resizeHeight);
</script>
<link href="doxypress.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by DoxyPress -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">Commanders
   </div>
   <div id="projectbrief">Arduino buttons/bus library</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by DoxyPress 1.2.10 -->
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
$(document).ready(function(){initNavTree('classCANCommanderClass.html','');});
</script>
<div id="doc-content">
<div class="header">
  <div class="summary">
<a href="#pub-methods">Public Member Functions</a> &#124;
<a href="#pub-static-methods">Static Public Member Functions</a> &#124;
<a href="classCANCommanderClass-members.html">List of all members</a>  </div>
  <div class="headertitle">
<div class="title">CANCommanderClass Class Reference</div>  </div>
  <div class="clear-floats"></div>
</div><!--header-->
<div class="contents">

<p><code>#include &quot;<a class="el" href="CANCommander_8hpp_source.html">CANCommander.hpp</a>&quot;</code></p>
<div class="dynheader">
Inheritance diagram for CANCommanderClass:</div>
<div class="dyncontent">
 <div class="center">
  <img src="classCANCommanderClass.png" usemap="#CANCommanderClass_map" alt=""/>
  <map id="CANCommanderClass_map" name="CANCommanderClass_map">
<area href="classCommander.html" alt="Commander" shape="rect" coords="0,0,137,24"/>
</map>
 </div></div>
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr class="memitem:ad0e2b4faecea168636d7b36b390e465d"><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classCANCommanderClass.html#ad0e2b4faecea168636d7b36b390e465d">CANCommanderClass</a> ()</td></tr>
<tr class="separator:ad0e2b4faecea168636d7b36b390e465d"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a192edd7c41059da4e7f201c4bb65684b"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classCANCommanderClass.html#a192edd7c41059da4e7f201c4bb65684b">begin</a> (uint8_t inSPIpin, uint8_t inSpeed, uint8_t inInterrupt, uint16_t inId)</td></tr>
<tr class="separator:a192edd7c41059da4e7f201c4bb65684b"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ac55b4d106afa8c09764931e287eb7c42"><td class="memItemLeft" align="right" valign="top">unsigned long&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classCANCommanderClass.html#ac55b4d106afa8c09764931e287eb7c42">loop</a> ()</td></tr>
<tr class="separator:ac55b4d106afa8c09764931e287eb7c42"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-static-methods"></a>
Static Public Member Functions</h2></td></tr>
<tr class="memitem:af75894cb98a2442642de7f565a6d67f8"><td class="memItemLeft" align="right" valign="top">static CANCommanderClass &amp;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classCANCommanderClass.html#af75894cb98a2442642de7f565a6d67f8">GetCurrent</a> ()</td></tr>
<tr class="separator:af75894cb98a2442642de7f565a6d67f8"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
<div class="textblock"><p>This <a class="el" href="classCommanders.html">Commanders</a> receive orders from the CAN bus, and translate it into <a class="el" href="classCommanders.html">Commanders</a> events.</p>
<p>This CAN bus used a MCP2515 chip, and use the library mcp_can for that. This library uses also the SPI bus to get data.</p>
<p>A sample of the library <a class="el" href="classCommanders.html">Commanders</a> give a sender of CAN events to <a class="el" href="classCommanders.html">Commanders</a>.</p>
<p>To work, the sender must send a message with the form of </p><pre class="fragment">IIIIEDD
</pre><p> where IIII is an unsigned long (four bytes) for the event id, E is the event type (see values of <a class="el" href="Events_8h.html#a36239a7eea6194f04e73e80d7419490c">COMMANDERS_EVENT_TYPE</a>), and DD the associated data.</p>
<p>Events thrown:</p>
<table class="doxtable">
<tr>
<th>reason </th><th>id </th><th>type </th><th>data  </th></tr>
<tr>
<td>message received </td><td>id </td><td>type </td><td>data </td></tr>
</table>

<p class="definition">Definition at line <a class="el" href="CANCommander_8hpp_source.html#l00033">33</a> of file <a class="el" href="CANCommander_8hpp_source.html">CANCommander.hpp</a>.</p>
</div><h2 class="groupheader">Constructor &amp; Destructor Documentation</h2>
<a class="anchor" id="ad0e2b4faecea168636d7b36b390e465d"></a>
<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">CANCommanderClass::CANCommanderClass </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p>Default constructor. </p>

<p class="definition">Definition at line <a class="el" href="CANCommander_8hpp_source.html#l00054">54</a> of file <a class="el" href="CANCommander_8hpp_source.html">CANCommander.hpp</a>.</p>

</div>
</div>
<h2 class="groupheader">Member Function Documentation</h2>
<a class="anchor" id="a192edd7c41059da4e7f201c4bb65684b"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void CANCommanderClass::begin </td>
          <td>(</td>
          <td class="paramtype">uint8_t&#160;</td>
          <td class="paramname"><em>inSPIpin</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">uint8_t&#160;</td>
          <td class="paramname"><em>inSpeed</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">uint8_t&#160;</td>
          <td class="paramname"><em>inInterrupt</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">uint16_t&#160;</td>
          <td class="paramname"><em>inId</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Initialize the instance. </p><dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">inSPIpin</td><td>pin for SPI to get data. </td></tr>
    <tr><td class="paramname">inSpeed</td><td>The speed can be (of course, use the defines from mcp_can_dfs.h)</td></tr>
  </table>
  </dd>
</dl>
<table class="doxtable">
<tr>
<th>Value </th><th>Speed (define name)  </th></tr>
<tr>
<td>1 </td><td>CAN_5KBPS </td></tr>
<tr>
<td>2 </td><td>CAN_10KBPS </td></tr>
<tr>
<td>3 </td><td>CAN_20KBPS </td></tr>
<tr>
<td>4 </td><td>CAN_25KBPS </td></tr>
<tr>
<td>5 </td><td>CAN_31K25BPS </td></tr>
<tr>
<td>6 </td><td>CAN_33KBPS </td></tr>
<tr>
<td>7 </td><td>CAN_40KBPS </td></tr>
<tr>
<td>8 </td><td>CAN_50KBPS </td></tr>
<tr>
<td>9 </td><td>CAN_80KBPS </td></tr>
<tr>
<td>10 </td><td>CAN_83K3BPS </td></tr>
<tr>
<td>11 </td><td>CAN_95KBPS </td></tr>
<tr>
<td>12 </td><td>CAN_100KBPS </td></tr>
<tr>
<td>13 </td><td>CAN_125KBPS </td></tr>
<tr>
<td>14 </td><td>CAN_200KBPS </td></tr>
<tr>
<td>15 </td><td>CAN_250KBPS </td></tr>
<tr>
<td>16 </td><td>CAN_500KBPS </td></tr>
<tr>
<td>17 </td><td>CAN_666KBPS </td></tr>
<tr>
<td>18 </td><td>CAN_1000KBPS </td></tr>
</table>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">inInterrupt</td><td>interrupt number for the reception. </td></tr>
    <tr><td class="paramname">inId</td><td>CAN id. Only the messages with this ID in the header will be read. </td></tr>
  </table>
  </dd>
</dl>

<p class="definition">Definition at line <a class="el" href="CANCommander_8cpp_source.html#l00030">30</a> of file <a class="el" href="CANCommander_8cpp_source.html">CANCommander.cpp</a>.</p>

</div>
</div>
<a class="anchor" id="af75894cb98a2442642de7f565a6d67f8"></a>
<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">static CANCommanderClass&amp; CANCommanderClass::GetCurrent </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">static</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p>Get the current instance of <a class="el" href="classDccCommanderClass.html">DccCommanderClass</a> </p><dl class="section remark"><dt>Remarks</dt><dd>This is an internal function. </dd></dl>

<p class="definition">Definition at line <a class="el" href="CANCommander_8hpp_source.html#l00092">92</a> of file <a class="el" href="CANCommander_8hpp_source.html">CANCommander.hpp</a>.</p>

</div>
</div>
<a class="anchor" id="ac55b4d106afa8c09764931e287eb7c42"></a>
<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">unsigned long CANCommanderClass::loop </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p>Main loop function. </p>

<p>Reimplemented from <a class="el" href="classCommander.html#ad071adf2b8c272269394c2c66bf46f00">Commander</a>.</p>

<p class="definition">Definition at line <a class="el" href="CANCommander_8cpp_source.html#l00123">123</a> of file <a class="el" href="CANCommander_8cpp_source.html">CANCommander.cpp</a>.</p>

</div>
</div>
<hr/>The documentation for this class was generated from the following files:<ul>
<li>D:/Mes documents/Trusty/Arduino/Libraries/Commanders/src/<a class="el" href="CANCommander_8hpp_source.html">CANCommander.hpp</a></li>
<li>D:/Mes documents/Trusty/Arduino/Libraries/Commanders/src/<a class="el" href="CANCommander_8cpp_source.html">CANCommander.cpp</a></li>
</ul>
</div><!-- contents -->
</div><!-- doc-content -->
<!-- Generated by DoxyPress 1.2.10 -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="navelem"><a class="el" href="classCANCommanderClass.html">CANCommanderClass</a></li>
    <li class="footer">Generated on mer. oct. 18 2017 17:55:02 for Commanders &nbsp; by
    <a href="http://www.copperspice.com/documentation-doxypress.html">
    <img class="footer" src="doxypress.png" alt="DoxyPress"/></a> 1.2.10 </li>
  </ul>
</div>
</body>
</html>
